diff --git a/bits/in.h b/bits/in.h
index 9f09776..8063a75 100644
--- a/bits/in.h
+++ b/bits/in.h
@@ -40,7 +40,7 @@
 #define	IP_RETOPTS	8	/* ip_opts; Set/get IP per-packet options.  */
 #define IP_MULTICAST_IF 9	/* in_addr; set/get IP multicast i/f */
 #define IP_MULTICAST_TTL 10	/* unsigned char; set/get IP multicast ttl */
-#define IP_MULTICAST_LOOP 11	/* i_char; set/get IP multicast loopback */
+#define IP_MULTICAST_LOOP 11	/* bool; set/get IP multicast loopback */
 #define IP_ADD_MEMBERSHIP 12	/* ip_mreq; add an IP group membership */
 #define IP_DROP_MEMBERSHIP 13	/* ip_mreq; drop an IP group membership */
 
diff --git a/gmon/sys/gmon.h b/gmon/sys/gmon.h
index 29cc321..b4cc3b0 100644
--- a/gmon/sys/gmon.h
+++ b/gmon/sys/gmon.h
@@ -130,7 +130,7 @@ extern struct __bb *__bb_head;
 #define MAXARCS		(1 << 20)
 
 struct tostruct {
-	unsigned long		selfpc;
+	unsigned long	selfpc;
 	long		count;
 	ARCINDEX	link;
 };
@@ -142,7 +142,7 @@ struct tostruct {
 struct rawarc {
 	unsigned long	raw_frompc;
 	unsigned long	raw_selfpc;
-	long	raw_count;
+	long		raw_count;
 };
 
 /*
@@ -156,17 +156,17 @@ struct rawarc {
  */
 struct gmonparam {
 	long int	state;
-	unsigned short		*kcount;
-	unsigned long		kcountsize;
+	unsigned short	*kcount;
+	unsigned long	kcountsize;
 	ARCINDEX	*froms;
-	unsigned long		fromssize;
+	unsigned long	fromssize;
 	struct tostruct	*tos;
-	unsigned long		tossize;
+	unsigned long	tossize;
 	long		tolimit;
-	unsigned long		lowpc;
-	unsigned long		highpc;
-	unsigned long		textsize;
-	unsigned long		hashfraction;
+	unsigned long	lowpc;
+	unsigned long	highpc;
+	unsigned long	textsize;
+	unsigned long	hashfraction;
 	long		log_hashfraction;
 };
 
diff --git a/include/arpa/nameser.h b/include/arpa/nameser.h
index 9da5420..ce6f023 100644
--- a/include/arpa/nameser.h
+++ b/include/arpa/nameser.h
@@ -47,8 +47,8 @@ extern const struct _ns_flagdata _ns_flagdata[] attribute_hidden;
 
 #endif
 
-extern unsigned int		__ns_get16 (const unsigned char *) __THROW;
-extern unsigned long		__ns_get32 (const unsigned char *) __THROW;
+extern unsigned int	__ns_get16 (const unsigned char *) __THROW;
+extern unsigned long	__ns_get32 (const unsigned char *) __THROW;
 
 #define ns_msg_getflag(handle, flag) \
   (((handle)._flags & _ns_flagdata[flag].mask) >> _ns_flagdata[flag].shift)
diff --git a/include/resolv.h b/include/resolv.h
index 2697c48..52ac218 100644
--- a/include/resolv.h
+++ b/include/resolv.h
@@ -45,12 +45,16 @@ libc_hidden_proto (__res_iclose)
 libc_hidden_proto (__res_randomid)
 libc_hidden_proto (__res_state)
 
-int __libc_res_nquery (res_state, const char *, int, int, unsigned char *, int,
-		       unsigned char **, unsigned char **, int *, int *, int *);
-int __libc_res_nsearch (res_state, const char *, int, int, unsigned char *, int,
-			unsigned char **, unsigned char **, int *, int *, int *);
-int __libc_res_nsend (res_state, const unsigned char *, int, const unsigned char *, int,
-		      unsigned char *, int, unsigned char **, unsigned char **, int *, int *, int *)
+int __libc_res_nquery (res_state, const char *, int, int,
+		       unsigned char *, int, unsigned char **,
+		       unsigned char **, int *, int *, int *);
+int __libc_res_nsearch (res_state, const char *, int, int,
+			unsigned char *, int, unsigned char **,
+			unsigned char **, int *, int *, int *);
+int __libc_res_nsend (res_state, const unsigned char *, int,
+		      const unsigned char *, int, unsigned char *,
+		      int, unsigned char **, unsigned char **,
+		      int *, int *, int *)
   attribute_hidden;
 
 libresolv_hidden_proto (_sethtent)
diff --git a/inet/netinet/igmp.h b/inet/netinet/igmp.h
index 314da39..ffbebc7 100644
--- a/inet/netinet/igmp.h
+++ b/inet/netinet/igmp.h
@@ -67,7 +67,7 @@ struct igmp {
   uint8_t igmp_type;             /* IGMP type */
   uint8_t igmp_code;             /* routing code */
   uint16_t igmp_cksum;           /* checksum */
-  struct in_addr igmp_group;      /* group address */
+  struct in_addr igmp_group;     /* group address */
 };
 
 #define IGMP_MINLEN			8
diff --git a/inet/protocols/talkd.h b/inet/protocols/talkd.h
index b37cfb5..0437ae4 100644
--- a/inet/protocols/talkd.h
+++ b/inet/protocols/talkd.h
@@ -57,9 +57,9 @@
  * Client->server request message format.
  */
 typedef struct {
-	unsigned char	vers;		/* protocol version */
-	unsigned char	type;		/* request type, see below */
-	unsigned char	answer;		/* not used */
+	unsigned char	vers;	/* protocol version */
+	unsigned char	type;	/* request type, see below */
+	unsigned char	answer;	/* not used */
 	unsigned char	pad;
 	uint32_t id_num;	/* message id */
 	struct	osockaddr addr;		/* old (4.3) style */
@@ -76,11 +76,11 @@ typedef struct {
  * Server->client response message format.
  */
 typedef struct {
-	unsigned char	vers;		/* protocol version */
-	unsigned char	type;		/* type of request message, see below */
-	unsigned char	answer;		/* response to request message, see below */
+	unsigned char	vers;	/* protocol version */
+	unsigned char	type;	/* type of request message, see below */
+	unsigned char	answer;	/* response to request message, see below */
 	unsigned char	pad;
-	uint32_t id_num;	/* message id */
+	uint32_t	id_num;	/* message id */
 	struct	osockaddr addr;	/* address for establishing conversation */
 } CTL_RESPONSE;
 
diff --git a/io/fts.h b/io/fts.h
index 806c5a1..607e8b1 100644
--- a/io/fts.h
+++ b/io/fts.h
@@ -105,8 +105,8 @@ typedef struct _ftsent {
 	char *fts_path;			/* root path */
 	int fts_errno;			/* errno for this node */
 	int fts_symfd;			/* fd for symlink */
-	unsigned short fts_pathlen;		/* strlen(fts_path) */
-	unsigned short fts_namelen;		/* strlen(fts_name) */
+	unsigned short fts_pathlen;	/* strlen(fts_path) */
+	unsigned short fts_namelen;	/* strlen(fts_name) */
 
 	ino_t fts_ino;			/* inode */
 	dev_t fts_dev;			/* device */
@@ -130,17 +130,17 @@ typedef struct _ftsent {
 #define	FTS_SL		12		/* symbolic link */
 #define	FTS_SLNONE	13		/* symbolic link without target */
 #define FTS_W		14		/* whiteout object */
-	unsigned short fts_info;		/* user flags for FTSENT structure */
+	unsigned short fts_info;	/* user flags for FTSENT structure */
 
 #define	FTS_DONTCHDIR	 0x01		/* don't chdir .. to the parent */
 #define	FTS_SYMFOLLOW	 0x02		/* followed a symlink to get here */
-	unsigned short fts_flags;		/* private flags for FTSENT structure */
+	unsigned short fts_flags;	/* private flags for FTSENT structure */
 
 #define	FTS_AGAIN	 1		/* read node again */
 #define	FTS_FOLLOW	 2		/* follow symbolic link */
 #define	FTS_NOINSTR	 3		/* no instructions */
 #define	FTS_SKIP	 4		/* discard node */
-	unsigned short fts_instr;		/* fts_set() instructions */
+	unsigned short fts_instr;	/* fts_set() instructions */
 
 	struct stat *fts_statp;		/* stat(2) information */
 	char fts_name[1];		/* file name */
@@ -166,11 +166,11 @@ typedef struct _ftsent64 {
 
 	short fts_level;		/* depth (-1 to N) */
 
-	unsigned short fts_info;		/* user flags for FTSENT structure */
+	unsigned short fts_info;	/* user flags for FTSENT structure */
 
-	unsigned short fts_flags;		/* private flags for FTSENT structure */
+	unsigned short fts_flags;	/* private flags for FTSENT structure */
 
-	unsigned short fts_instr;		/* fts_set() instructions */
+	unsigned short fts_instr;	/* fts_set() instructions */
 
 	struct stat64 *fts_statp;	/* stat(2) information */
 	char fts_name[1];		/* file name */
diff --git a/resolv/arpa/nameser.h b/resolv/arpa/nameser.h
index 3ef1266..9d12b53 100644
--- a/resolv/arpa/nameser.h
+++ b/resolv/arpa/nameser.h
@@ -92,10 +92,10 @@ typedef enum __ns_sect {
  */
 typedef struct __ns_msg {
 	const unsigned char	*_msg, *_eom;
-	uint16_t	_id, _flags, _counts[ns_s_max];
+	uint16_t		_id, _flags, _counts[ns_s_max];
 	const unsigned char	*_sections[ns_s_max];
-	ns_sect		_sect;
-	int		_rrnum;
+	ns_sect			_sect;
+	int			_rrnum;
 	const unsigned char	*_msg_ptr;
 } ns_msg;
 
@@ -115,11 +115,11 @@ extern const struct _ns_flagdata _ns_flagdata[];
  * This is a parsed record.  It is caller allocated and has no dynamic data.
  */
 typedef	struct __ns_rr {
-	char		name[NS_MAXDNAME];
-	uint16_t	type;
-	uint16_t	rr_class;
-	uint32_t	ttl;
-	uint16_t	rdlength;
+	char			name[NS_MAXDNAME];
+	uint16_t		type;
+	uint16_t		rr_class;
+	uint32_t		ttl;
+	uint16_t		rdlength;
 	const unsigned char *	rdata;
 } ns_rr;
 
@@ -354,37 +354,45 @@ typedef enum __ns_cert_types {
 
 __BEGIN_DECLS
 int		ns_msg_getflag (ns_msg, int) __THROW;
-unsigned int		ns_get16 (const unsigned char *) __THROW;
-unsigned long		ns_get32 (const unsigned char *) __THROW;
+unsigned int	ns_get16 (const unsigned char *) __THROW;
+unsigned long	ns_get32 (const unsigned char *) __THROW;
 void		ns_put16 (unsigned int, unsigned char *) __THROW;
 void		ns_put32 (unsigned long, unsigned char *) __THROW;
 int		ns_initparse (const unsigned char *, int, ns_msg *) __THROW;
-int		ns_skiprr (const unsigned char *, const unsigned char *, ns_sect, int)
-     __THROW;
+int		ns_skiprr (const unsigned char *, const unsigned char *,
+			   ns_sect, int) __THROW;
 int		ns_parserr (ns_msg *, ns_sect, int, ns_rr *) __THROW;
 int		ns_sprintrr (const ns_msg *, const ns_rr *,
 			     const char *, const char *, char *, size_t)
      __THROW;
 int		ns_sprintrrf (const unsigned char *, size_t, const char *,
-			      ns_class, ns_type, unsigned long, const unsigned char *,
-			      size_t, const char *, const char *,
-			      char *, size_t) __THROW;
+			      ns_class, ns_type, unsigned long,
+			      const unsigned char *, size_t, const char *,
+			      const char *, char *, size_t) __THROW;
 int		ns_format_ttl (unsigned long, char *, size_t) __THROW;
 int		ns_parse_ttl (const char *, unsigned long *) __THROW;
 uint32_t	ns_datetosecs (const char *, int *) __THROW;
-int		ns_name_ntol (const unsigned char *, unsigned char *, size_t) __THROW;
+int		ns_name_ntol (const unsigned char *, unsigned char *, size_t)
+     __THROW;
 int		ns_name_ntop (const unsigned char *, char *, size_t) __THROW;
 int		ns_name_pton (const char *, unsigned char *, size_t) __THROW;
 int		ns_name_unpack (const unsigned char *, const unsigned char *,
-				const unsigned char *, unsigned char *, size_t) __THROW;
+				const unsigned char *, unsigned char *, size_t)
+     __THROW;
 int		ns_name_pack (const unsigned char *, unsigned char *, int,
-			      const unsigned char **, const unsigned char **) __THROW;
-int		ns_name_uncompress (const unsigned char *, const unsigned char *,
-				    const unsigned char *, char *, size_t) __THROW;
+			      const unsigned char **, const unsigned char **)
+     __THROW;
+int		ns_name_uncompress (const unsigned char *,
+				    const unsigned char *,
+				    const unsigned char *,
+				    char *, size_t) __THROW;
 int		ns_name_compress (const char *, unsigned char *, size_t,
-				  const unsigned char **, const unsigned char **) __THROW;
-int		ns_name_skip (const unsigned char **, const unsigned char *) __THROW;
-void		ns_name_rollback (const unsigned char *, const unsigned char **,
+				  const unsigned char **,
+				  const unsigned char **) __THROW;
+int		ns_name_skip (const unsigned char **, const unsigned char *)
+     __THROW;
+void		ns_name_rollback (const unsigned char *,
+				  const unsigned char **,
 				  const unsigned char **) __THROW;
 int		ns_samedomain (const char *, const char *) __THROW;
 int		ns_subdomain (const char *, const char *) __THROW;
diff --git a/resolv/resolv.h b/resolv/resolv.h
index fe3f56d..58c3c38 100644
--- a/resolv/resolv.h
+++ b/resolv/resolv.h
@@ -87,16 +87,16 @@
 struct __res_state {
 	int	retrans;		/* retransmition time interval */
 	int	retry;			/* number of times to retransmit */
-	unsigned long	options;		/* option flags - see below. */
+	unsigned long options;		/* option flags - see below. */
 	int	nscount;		/* number of name servers */
 	struct sockaddr_in
 		nsaddr_list[MAXNS];	/* address of name server */
 # define nsaddr	nsaddr_list[0]		/* for backward compatibility */
-	unsigned short	id;			/* current message id */
+	unsigned short id;		/* current message id */
 	/* 2 byte hole here.  */
 	char	*dnsrch[MAXDNSRCH+1];	/* components of domain to search */
 	char	defdname[256];		/* default domain (deprecated) */
-	unsigned long	pfcode;			/* RES_PRF_ flags - see below. */
+	unsigned long pfcode;		/* RES_PRF_ flags - see below. */
 	unsigned ndots:4;		/* threshold for initial abs. query */
 	unsigned nsort:4;		/* number of elements in sort_list[] */
 	unsigned ipv6_unavail:1;	/* connecting to IPv6 server failed */
@@ -110,7 +110,7 @@ struct __res_state {
 	void * __glibc_unused_rhook;
 	int	res_h_errno;		/* last one set for this context */
 	int	_vcsock;		/* PRIVATE: for res_send VC i/o */
-	unsigned int	_flags;			/* PRIVATE: see below */
+	unsigned int _flags;		/* PRIVATE: see below */
 	/* 4 byte hole here on 64-bit architectures.  */
 	union {
 		char	pad[52];	/* On an i386 this means 512b total. */
@@ -254,13 +254,17 @@ void		p_query (const unsigned char *) __THROW;
 void		res_close (void) __THROW;
 int		res_init (void) __THROW;
 int		res_isourserver (const struct sockaddr_in *) __THROW;
-int		res_mkquery (int, const char *, int, int, const unsigned char *,
-			     int, const unsigned char *, unsigned char *, int) __THROW;
-int		res_query (const char *, int, int, unsigned char *, int) __THROW;
+int		res_mkquery (int, const char *, int, int,
+			     const unsigned char *, int, const unsigned char *,
+			     unsigned char *, int) __THROW;
+int		res_query (const char *, int, int, unsigned char *, int)
+     __THROW;
 int		res_querydomain (const char *, const char *, int, int,
 				 unsigned char *, int) __THROW;
-int		res_search (const char *, int, int, unsigned char *, int) __THROW;
-int		res_send (const unsigned char *, int, unsigned char *, int) __THROW;
+int		res_search (const char *, int, int, unsigned char *, int)
+     __THROW;
+int		res_send (const unsigned char *, int, unsigned char *, int)
+     __THROW;
 __END_DECLS
 
 #define b64_ntop		__b64_ntop
@@ -313,56 +317,65 @@ int		res_dnok (const char *) __THROW;
 int		sym_ston (const struct res_sym *, const char *, int *) __THROW;
 const char *	sym_ntos (const struct res_sym *, int, int *) __THROW;
 const char *	sym_ntop (const struct res_sym *, int, int *) __THROW;
-int		b64_ntop (unsigned char const *, size_t, char *, size_t) __THROW;
+int		b64_ntop (const unsigned char *, size_t, char *, size_t)
+     __THROW;
 int		b64_pton (char const *, unsigned char *, size_t) __THROW;
 int		loc_aton (const char *__ascii, unsigned char *__binary) __THROW;
 const char *	loc_ntoa (const unsigned char *__binary, char *__ascii) __THROW;
-int		dn_skipname (const unsigned char *, const unsigned char *) __THROW;
+int		dn_skipname (const unsigned char *, const unsigned char *)
+     __THROW;
 void		putlong (uint32_t, unsigned char *) __THROW;
 void		putshort (uint16_t, unsigned char *) __THROW;
 const char *	p_class (int) __THROW;
 const char *	p_time (uint32_t) __THROW;
 const char *	p_type (int) __THROW;
 const char *	p_rcode (int) __THROW;
-const unsigned char *	p_cdnname (const unsigned char *, const unsigned char *, int, FILE *)
-     __THROW;
-const unsigned char *	p_cdname (const unsigned char *, const unsigned char *, FILE *) __THROW;
-const unsigned char *	p_fqnname (const unsigned char *__cp, const unsigned char *__msg,
-			   int, char *, int) __THROW;
-const unsigned char *	p_fqname (const unsigned char *, const unsigned char *, FILE *) __THROW;
+const unsigned char * p_cdnname (const unsigned char *,
+				 const unsigned char *, int, FILE *) __THROW;
+const unsigned char * p_cdname (const unsigned char *, const unsigned char *,
+				FILE *) __THROW;
+const unsigned char * p_fqnname (const unsigned char *__cp,
+				 const unsigned char *__msg,
+				 int, char *, int) __THROW;
+const unsigned char * p_fqname (const unsigned char *,
+				const unsigned char *, FILE *) __THROW;
 const char *	p_option (unsigned long __option) __THROW;
 char *		p_secstodate (unsigned long) __THROW;
 int		dn_count_labels (const char *) __THROW;
-int		dn_comp (const char *, unsigned char *, int, unsigned char **, unsigned char **)
-     __THROW;
-int		dn_expand (const unsigned char *, const unsigned char *, const unsigned char *,
-			   char *, int) __THROW;
-unsigned int		res_randomid (void) __THROW;
+int		dn_comp (const char *, unsigned char *, int, unsigned char **,
+			 unsigned char **) __THROW;
+int		dn_expand (const unsigned char *, const unsigned char *,
+			   const unsigned char *, char *, int) __THROW;
+unsigned int	res_randomid (void) __THROW;
 int		res_nameinquery (const char *, int, int,
-				 const unsigned char *, const unsigned char *) __THROW;
-int		res_queriesmatch (const unsigned char *, const unsigned char *,
-				  const unsigned char *, const unsigned char *) __THROW;
+				 const unsigned char *,
+				 const unsigned char *) __THROW;
+int		res_queriesmatch (const unsigned char *,
+				  const unsigned char *,
+				  const unsigned char *,
+				  const unsigned char *) __THROW;
 const char *	p_section (int __section, int __opcode) __THROW;
 /* Things involving a resolver context. */
 int		res_ninit (res_state) __THROW;
 int		res_nisourserver (const res_state,
 				  const struct sockaddr_in *) __THROW;
 void		fp_resstat (const res_state, FILE *) __THROW;
-void		res_npquery (const res_state, const unsigned char *, int, FILE *)
-     __THROW;
+void		res_npquery (const res_state, const unsigned char *, int,
+			     FILE *) __THROW;
 const char *	res_hostalias (const res_state, const char *, char *, size_t)
      __THROW;
-int		res_nquery (res_state, const char *, int, int, unsigned char *, int)
-     __THROW;
-int		res_nsearch (res_state, const char *, int, int, unsigned char *, int)
-     __THROW;
+int		res_nquery (res_state, const char *, int, int,
+			    unsigned char *, int) __THROW;
+int		res_nsearch (res_state, const char *, int, int,
+			     unsigned char *, int) __THROW;
 int		res_nquerydomain (res_state, const char *, const char *, int,
 				  int, unsigned char *, int) __THROW;
 int		res_nmkquery (res_state, int, const char *, int, int,
-			      const unsigned char *, int, const unsigned char *, unsigned char *,
-			      int) __THROW;
-int		res_nsend (res_state, const unsigned char *, int, unsigned char *, int)
+			      const unsigned char *, int,
+			      const unsigned char *, unsigned char *, int)
      __THROW;
+int		res_nsend (res_state, const unsigned char *, int,
+			   unsigned char *, int) __THROW;
 void		res_nclose (res_state) __THROW;
 __END_DECLS
 #endif
diff --git a/sunrpc/rpc/rpc_des.h b/sunrpc/rpc/rpc_des.h
index 4722392..2091f52 100644
--- a/sunrpc/rpc/rpc_des.h
+++ b/sunrpc/rpc/rpc_des.h
@@ -53,10 +53,10 @@ enum desmode
  */
 struct desparams
   {
-    unsigned char des_key[8];		/* key (with low bit parity) */
+    unsigned char des_key[8];	/* key (with low bit parity) */
     enum desdir des_dir;	/* direction */
     enum desmode des_mode;	/* mode */
-    unsigned char des_ivec[8];		/* input vector */
+    unsigned char des_ivec[8];	/* input vector */
     unsigned des_len;		/* number of bytes to crypt */
     union
       {
diff --git a/sysdeps/generic/netinet/ip.h b/sysdeps/generic/netinet/ip.h
index f7adbaf..5f16c9a 100644
--- a/sysdeps/generic/netinet/ip.h
+++ b/sysdeps/generic/netinet/ip.h
@@ -115,16 +115,16 @@ struct ip
     unsigned int ip_hl:4;		/* header length */
 #endif
     uint8_t ip_tos;			/* type of service */
-    unsigned short ip_len;			/* total length */
-    unsigned short ip_id;			/* identification */
-    unsigned short ip_off;			/* fragment offset field */
+    unsigned short ip_len;		/* total length */
+    unsigned short ip_id;		/* identification */
+    unsigned short ip_off;		/* fragment offset field */
 #define	IP_RF 0x8000			/* reserved fragment flag */
 #define	IP_DF 0x4000			/* dont fragment flag */
 #define	IP_MF 0x2000			/* more fragments flag */
 #define	IP_OFFMASK 0x1fff		/* mask for fragmenting bits */
     uint8_t ip_ttl;			/* time to live */
     uint8_t ip_p;			/* protocol */
-    unsigned short ip_sum;			/* checksum */
+    unsigned short ip_sum;		/* checksum */
     struct in_addr ip_src, ip_dst;	/* source and dest address */
   };
 
diff --git a/sysdeps/generic/netinet/tcp.h b/sysdeps/generic/netinet/tcp.h
index f84273e..49f1bfb 100644
--- a/sysdeps/generic/netinet/tcp.h
+++ b/sysdeps/generic/netinet/tcp.h
@@ -43,17 +43,17 @@ typedef	unsigned int	tcp_seq;
  * Per RFC 793, September, 1981.
  */
 struct tcphdr {
-	unsigned short	th_sport;		/* source port */
-	unsigned short	th_dport;		/* destination port */
-	tcp_seq	th_seq;			/* sequence number */
-	tcp_seq	th_ack;			/* acknowledgement number */
+	unsigned short	th_sport;	/* source port */
+	unsigned short	th_dport;	/* destination port */
+	tcp_seq		th_seq;		/* sequence number */
+	tcp_seq		th_ack;		/* acknowledgement number */
 #if __BYTE_ORDER == __LITTLE_ENDIAN
-	unsigned char	th_x2:4,		/* (unused) */
-		th_off:4;		/* data offset */
+	unsigned char	th_x2:4,	/* (unused) */
+			th_off:4;	/* data offset */
 #endif
 #if __BYTE_ORDER == __BIG_ENDIAN
-	unsigned char	th_off:4,		/* data offset */
-		th_x2:4;		/* (unused) */
+	unsigned char	th_off:4,	/* data offset */
+			th_x2:4;	/* (unused) */
 #endif
 	unsigned char	th_flags;
 #define	TH_FIN	0x01
@@ -62,23 +62,23 @@ struct tcphdr {
 #define	TH_PUSH	0x08
 #define	TH_ACK	0x10
 #define	TH_URG	0x20
-	unsigned short	th_win;			/* window */
-	unsigned short	th_sum;			/* checksum */
-	unsigned short	th_urp;			/* urgent pointer */
+	unsigned short	th_win;		/* window */
+	unsigned short	th_sum;		/* checksum */
+	unsigned short	th_urp;		/* urgent pointer */
 };
 
 #define	TCPOPT_EOL		0
 #define	TCPOPT_NOP		1
 #define	TCPOPT_MAXSEG		2
-#define    TCPOLEN_MAXSEG		4
+#define TCPOLEN_MAXSEG		4
 #define TCPOPT_WINDOW		3
-#define    TCPOLEN_WINDOW		3
+#define TCPOLEN_WINDOW		3
 #define TCPOPT_SACK_PERMITTED	4		/* Experimental */
-#define    TCPOLEN_SACK_PERMITTED	2
+#define TCPOLEN_SACK_PERMITTED	2
 #define TCPOPT_SACK		5		/* Experimental */
 #define TCPOPT_TIMESTAMP	8
-#define    TCPOLEN_TIMESTAMP		10
-#define    TCPOLEN_TSTAMP_APPA		(TCPOLEN_TIMESTAMP+2) /* appendix A */
+#define TCPOLEN_TIMESTAMP	10
+#define TCPOLEN_TSTAMP_APPA	(TCPOLEN_TIMESTAMP+2) /* appendix A */
 
 #define TCPOPT_TSTAMP_HDR	\
     (TCPOPT_NOP<<24|TCPOPT_NOP<<16|TCPOPT_TIMESTAMP<<8|TCPOLEN_TIMESTAMP)
diff --git a/sysdeps/gnu/netinet/ip_icmp.h b/sysdeps/gnu/netinet/ip_icmp.h
index aceffc8..e57b144 100644
--- a/sysdeps/gnu/netinet/ip_icmp.h
+++ b/sysdeps/gnu/netinet/ip_icmp.h
@@ -141,7 +141,7 @@ struct icmp
   uint16_t icmp_cksum;	/* ones complement checksum of struct */
   union
   {
-    unsigned char ih_pptr;		/* ICMP_PARAMPROB */
+    unsigned char ih_pptr;	/* ICMP_PARAMPROB */
     struct in_addr ih_gwaddr;	/* gateway address */
     struct ih_idseq		/* echo datagram */
     {
diff --git a/sysdeps/gnu/netinet/tcp.h b/sysdeps/gnu/netinet/tcp.h
index 38d5310..42ec108 100644
--- a/sysdeps/gnu/netinet/tcp.h
+++ b/sysdeps/gnu/netinet/tcp.h
@@ -85,17 +85,17 @@ struct tcphdr
     {
       struct
       {
-	uint16_t th_sport;		/* source port */
-	uint16_t th_dport;		/* destination port */
+	uint16_t th_sport;	/* source port */
+	uint16_t th_dport;	/* destination port */
 	tcp_seq th_seq;		/* sequence number */
 	tcp_seq th_ack;		/* acknowledgement number */
 # if __BYTE_ORDER == __LITTLE_ENDIAN
-	uint8_t th_x2:4;		/* (unused) */
-	uint8_t th_off:4;		/* data offset */
+	uint8_t th_x2:4;	/* (unused) */
+	uint8_t th_off:4;	/* data offset */
 # endif
 # if __BYTE_ORDER == __BIG_ENDIAN
-	uint8_t th_off:4;		/* data offset */
-	uint8_t th_x2:4;		/* (unused) */
+	uint8_t th_off:4;	/* data offset */
+	uint8_t th_x2:4;	/* (unused) */
 # endif
 	uint8_t th_flags;
 # define TH_FIN	0x01
@@ -104,9 +104,9 @@ struct tcphdr
 # define TH_PUSH	0x08
 # define TH_ACK	0x10
 # define TH_URG	0x20
-	uint16_t th_win;		/* window */
-	uint16_t th_sum;		/* checksum */
-	uint16_t th_urp;		/* urgent pointer */
+	uint16_t th_win;	/* window */
+	uint16_t th_sum;	/* checksum */
+	uint16_t th_urp;	/* urgent pointer */
       };
       struct
       {
diff --git a/sysdeps/gnu/netinet/udp.h b/sysdeps/gnu/netinet/udp.h
index 31ba1b5..f55391c 100644
--- a/sysdeps/gnu/netinet/udp.h
+++ b/sysdeps/gnu/netinet/udp.h
@@ -59,8 +59,8 @@ struct udphdr
   {
     struct
     {
-      uint16_t uh_sport;		/* source port */
-      uint16_t uh_dport;		/* destination port */
+      uint16_t uh_sport;	/* source port */
+      uint16_t uh_dport;	/* destination port */
       uint16_t uh_ulen;		/* udp length */
       uint16_t uh_sum;		/* udp checksum */
     };
diff --git a/sysdeps/mach/hurd/net/if_ppp.h b/sysdeps/mach/hurd/net/if_ppp.h
index bef4b57..b210d7f 100644
--- a/sysdeps/mach/hurd/net/if_ppp.h
+++ b/sysdeps/mach/hurd/net/if_ppp.h
@@ -115,7 +115,7 @@ struct npioctl {
 /* Structure describing a CCP configuration option, for PPPIOCSCOMPRESS */
 struct ppp_option_data {
 	uint8_t  *ptr;
-	uint32_t length;
+	uint32_t  length;
 	int	  transmit;
 };
 
diff --git a/sysdeps/mach/sys/reboot.h b/sysdeps/mach/sys/reboot.h
index 6dde934..9beb8ae 100644
--- a/sysdeps/mach/sys/reboot.h
+++ b/sysdeps/mach/sys/reboot.h
@@ -145,8 +145,8 @@
 #define	B_TYPEMASK		0xff
 #define	B_TYPE(val)		(((val) >> B_TYPESHIFT) & B_TYPEMASK)
 
-#define	B_MAGICMASK	((unsigned int)0xf0000000U)
-#define	B_DEVMAGIC	((unsigned int)0xa0000000U)
+#define	B_MAGICMASK	0xf0000000U
+#define	B_DEVMAGIC	0xa0000000U
 
 #define MAKEBOOTDEV(type, adaptor, controller, unit, partition) \
 	(((type) << B_TYPESHIFT) | ((adaptor) << B_ADAPTORSHIFT) | \
diff --git a/sysdeps/unix/sysv/linux/bits/in.h b/sysdeps/unix/sysv/linux/bits/in.h
index b099839..f2824bb 100644
--- a/sysdeps/unix/sysv/linux/bits/in.h
+++ b/sysdeps/unix/sysv/linux/bits/in.h
@@ -54,7 +54,7 @@
 #define        IP_RETOPTS      7       /* ip_opts; Set/get IP per-packet options.  */
 #define IP_MULTICAST_IF 32	/* in_addr; set/get IP multicast i/f */
 #define IP_MULTICAST_TTL 33	/* unsigned char; set/get IP multicast ttl */
-#define IP_MULTICAST_LOOP 34	/* i_char; set/get IP multicast loopback */
+#define IP_MULTICAST_LOOP 34	/* bool; set/get IP multicast loopback */
 #define IP_ADD_MEMBERSHIP 35	/* ip_mreq; add an IP group membership */
 #define IP_DROP_MEMBERSHIP 36	/* ip_mreq; drop an IP group membership */
 #define IP_UNBLOCK_SOURCE 37	/* ip_mreq_source: unblock data from source */
diff --git a/sysdeps/unix/sysv/linux/net/if_ppp.h b/sysdeps/unix/sysv/linux/net/if_ppp.h
index bef4b57..20310eb 100644
--- a/sysdeps/unix/sysv/linux/net/if_ppp.h
+++ b/sysdeps/unix/sysv/linux/net/if_ppp.h
@@ -116,7 +116,7 @@ struct npioctl {
 struct ppp_option_data {
 	uint8_t  *ptr;
 	uint32_t length;
-	int	  transmit;
+	int	 transmit;
 };
 
 struct ifpppstatsreq {
diff --git a/sysdeps/unix/sysv/linux/netinet/if_ether.h b/sysdeps/unix/sysv/linux/netinet/if_ether.h
index 85b4cf4..ccd8ceb 100644
--- a/sysdeps/unix/sysv/linux/netinet/if_ether.h
+++ b/sysdeps/unix/sysv/linux/netinet/if_ether.h
@@ -88,7 +88,7 @@ struct	ether_arp {
  */
 #define ETHER_MAP_IP_MULTICAST(ipaddr, enaddr) \
 	/* struct in_addr *ipaddr; */ \
-	/* unsigned char enaddr[ETH_ALEN];	   */ \
+	/* uint8_t enaddr[ETH_ALEN]; */ \
 { \
 	(enaddr)[0] = 0x01; \
 	(enaddr)[1] = 0x00; \
diff --git a/sysdeps/unix/sysv/linux/netinet/if_tr.h b/sysdeps/unix/sysv/linux/netinet/if_tr.h
index d7fdf7c..5df2206 100644
--- a/sysdeps/unix/sysv/linux/netinet/if_tr.h
+++ b/sysdeps/unix/sysv/linux/netinet/if_tr.h
@@ -39,7 +39,7 @@ struct trh_hdr
   uint8_t  fc;			/* frame control field */
   uint8_t  daddr[TR_ALEN];	/* destination address */
   uint8_t  saddr[TR_ALEN];	/* source address */
-  uint16_t rcf;		/* route control field */
+  uint16_t rcf;			/* route control field */
   uint16_t rseg[8];		/* routing registers */
 };
 
@@ -48,7 +48,7 @@ struct trllc
 {
   uint8_t  dsap;		/* destination SAP */
   uint8_t  ssap;		/* source SAP */
-  uint8_t  llc;		/* LLC control field */
+  uint8_t  llc;			/* LLC control field */
   uint8_t  protid[3];		/* protocol id */
   uint16_t ethertype;		/* ether type field */
 };
diff --git a/sysdeps/unix/sysv/linux/sys/acct.h b/sysdeps/unix/sysv/linux/sys/acct.h
index 1e4a114..c629ad4 100644
--- a/sysdeps/unix/sysv/linux/sys/acct.h
+++ b/sysdeps/unix/sysv/linux/sys/acct.h
@@ -53,7 +53,7 @@ struct acct
   comp_t ac_minflt;		/* Minor pagefaults.  */
   comp_t ac_majflt;		/* Major pagefaults.  */
   comp_t ac_swaps;		/* Number of swaps.  */
-  uint32_t ac_exitcode;	/* Process exitcode.  */
+  uint32_t ac_exitcode;		/* Process exitcode.  */
   char ac_comm[ACCT_COMM+1];	/* Command name.  */
   char ac_pad[10];		/* Padding bytes.  */
 };
@@ -64,7 +64,7 @@ struct acct_v3
   char ac_flag;			/* Flags */
   char ac_version;		/* Always set to ACCT_VERSION */
   uint16_t ac_tty;		/* Control Terminal */
-  uint32_t ac_exitcode;	/* Exitcode */
+  uint32_t ac_exitcode;		/* Exitcode */
   uint32_t ac_uid;		/* Real User ID */
   uint32_t ac_gid;		/* Real Group ID */
   uint32_t ac_pid;		/* Process ID */